<template>
  <div>
    <form class="form sw-gs-form-client-name" v-if="!formSubmitted" @submit="sendName">
      <SwInput v-if="!showTokenPermissionsRequest"
               v-model="name"
               :label="$t('Name')"
               name="name"
               class="form__element sw-gs-form-client-name-input"
               :valid="!$v.name.$error"
               :error-message="$t('Please enter your name. The minimum length is 3 letters and the maximum 30 letters.')"
               :disabled="attendeeRestrictionType === 'customer'"
               @blur="$v.name.$touch()"/>

      <SwCheckbox v-model="cartPermissions" v-if="allowUserActionsForGuide"
                  :label="$t('Allow guide to update your cart contents for you.')"
                  name="cartPermissions"
                  class="form__element sw-gs-form-client-cartPermissions-input"/>
      
      <SfCheckbox v-if="videoAndAudioSetting && !showTokenPermissionsRequest && attendeeRestrictionType === 'open'"
                  class="form__element sw-gs-form-client-acceptance-input"
                  v-model="acceptance"
                  name="checkbox"
      >
        <template #label>
          <span class="sf-checkbox__label" v-html="$t('I accept the privacy policy of daily.co')" />
        </template>
      </SfCheckbox>
      <!-- here -->

      <SwButton class="sw-gs-form-client-name-submit" :disabled="$v.$invalid" type="submit">
        {{ $t('Send') }}
      </SwButton>
    </form>
    <template v-else>
      <div class="sw-gs-form-client-name">
        <p>
          {{ $t('Thank you! Your configuration was saved.') }} </p>

        <SwButton class="sw-gs-form-client-name-edit" type="button" @click="showForm">
          {{ $t('Edit configuration') }}
        </SwButton>
      </div>
    </template>
  </div>
</template>

<script>
  import useVuelidate from "@vuelidate/core"
  import { minLength, maxLength } from "@vuelidate/validators"
  import SwButton from "@/components/atoms/SwButton.vue"
  import SwInput from "@/components/atoms/SwInput.vue"
  import { ref, reactive, toRefs, computed } from "@vue/composition-api";
  import { useAppointment } from "../logic/composables/useAppointment";
  import { useState } from "../logic/composables/useState";
  import { useMercureObserver } from "../logic/composables/useMercureObserver";
  import { useMercure } from "../logic/composables/useMercure";
  import { SfCheckbox } from "@storefront-ui/vue";
  import SwCheckbox from "@/components/atoms/SwCheckbox.vue";

  export default {
    name: "SwGsAttendeeNameForm",
    components: {
      SwButton,
      SwInput,
      SfCheckbox,
      SwCheckbox
    },
    setup({}, { emit }) {
      const { showTokenPermissionsRequest, stateForAll, loadState } = useState();
      const { requestedTokenPermissions } = useMercureObserver();
      const { mercurePublish } = useMercure();
      const { updateAttendeeData, getAttendeeName, appointment, videoAndAudioSetting } = useAppointment();
      const formSubmitted = ref(false);

      const state = reactive({
        name: getAttendeeName(),
        cartPermissions: false,
        acceptance: false
      });

      const rules = {
        name: {
          minLength: minLength(3),
          maxLength: maxLength(30)
        },
        acceptance: {
          checked: value => {
            if (!videoAndAudioSetting.value || showTokenPermissionsRequest.value || stateForAll.value?.attendeeRestrictionType !== 'open') {
              return true;
            } else {
              return value === true
            }
          }
        }
      }
      const $v = useVuelidate(rules, state);

      async function sendName(e) {
        e.preventDefault()
        $v.value.$touch()

        if ($v.value.$invalid) {
          return;
        }

        const data = {
          guideCartPermissionsGranted: state.cartPermissions,
          attendeeSubmitted: true
        };
        if (state.name) data['attendeeName'] = state.name;

        await updateAttendeeData(data);
        await loadState(true);

        if (state.cartPermissions) {
          mercurePublish.client('grantedTokenPermissions', appointment.value.attendeeId);
        }

        formSubmitted.value = true;
        emit('save-attendee-name');

        // reset cart permissions request
        if (showTokenPermissionsRequest.value) {
          requestedTokenPermissions.value = null;
        }
      }

      function showForm() {
        formSubmitted.value = false;
      }

      return {
        $v,
        ...toRefs(state),
        sendName,
        formSubmitted,
        showForm,
        videoAndAudioSetting,
        showTokenPermissionsRequest,
        allowUserActionsForGuide: computed(() => stateForAll.value?.allowUserActionsForGuide),
        attendeeRestrictionType: computed(() => stateForAll.value?.attendeeRestrictionType),
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .sw-gs-form-client-name {
    margin-top: 20px;
  }

  .sw-gs-form-client-name-input {
    margin-bottom: var(--spacer-xs);
  }

  .sw-gs-form-client-cartPermissions-input, .sw-gs-form-client-acceptance-input {
    margin-bottom: var(--spacer-base);
  }

  .sw-gs-form-client-name-edit {
    margin: 0 auto;
  }

  .sw-gs-form-client-info {
    margin-bottom: var(--spacer-base);
  }

</style>
